#ifndef _Handle_PTopoDS_HShape_HeaderFile
#define _Handle_PTopoDS_HShape_HeaderFile

#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

#ifndef _Handle_ObjMgt_ExternShareable_HeaderFile
#include <Handle_ObjMgt_ExternShareable.hxx>
#endif
#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif

class Standard_Persistent;
class Handle_Standard_Type;
class Handle(ObjMgt_ExternShareable);
class PTopoDS_HShape;
Standard_EXPORT Handle_Standard_Type& STANDARD_TYPE(PTopoDS_HShape);

class Handle(PTopoDS_HShape) : public Handle(ObjMgt_ExternShareable) {
  public:

    Handle(PTopoDS_HShape)():Handle(ObjMgt_ExternShareable)() {} 
    Handle(PTopoDS_HShape)(const Handle(PTopoDS_HShape)& aHandle) : Handle(ObjMgt_ExternShareable)(aHandle) 
     {
     }

    Handle(PTopoDS_HShape)(const PTopoDS_HShape* anItem) : Handle(ObjMgt_ExternShareable)((ObjMgt_ExternShareable *)anItem) 
     {
     }

    Handle(PTopoDS_HShape)& operator=(const Handle(PTopoDS_HShape)& aHandle)
     {
      Assign(aHandle.Access());
      return *this;
     }

    Handle(PTopoDS_HShape)& operator=(const PTopoDS_HShape* anItem)
     {
      Assign((Standard_Persistent *)anItem);
      return *this;
     }

    PTopoDS_HShape* operator->() const 
     {
      return (PTopoDS_HShape *)ControlAccess();
     }

   Standard_EXPORT static const Handle(PTopoDS_HShape) DownCast(const Handle(Standard_Persistent)& AnObject);
};
#endif
